VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form formMain 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00C0FFFF&
   Caption         =   "Differential Conductance"
   ClientHeight    =   7005
   ClientLeft      =   120
   ClientTop       =   4200
   ClientWidth     =   10005
   Icon            =   "formMain.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   ScaleHeight     =   7005
   ScaleWidth      =   10005
   Begin VB.Frame Frame10 
      BackColor       =   &H00E0FFE0&
      Caption         =   "Dwell"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   700
      Left            =   6900
      TabIndex        =   57
      Top             =   700
      Width           =   1000
      Begin VB.TextBox txtDwellSeq 
         Alignment       =   2  'Center
         BackColor       =   &H00E0FFE0&
         Height          =   300
         Left            =   100
         MaxLength       =   4
         TabIndex        =   58
         TabStop         =   0   'False
         Text            =   "500"
         ToolTipText     =   "Dwell time to let DC settle (0-5000mS)"
         Top             =   300
         Width           =   600
      End
   End
   Begin VB.Timer tmrMeasSeq 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   6930
      Top             =   1500
   End
   Begin VB.CommandButton cmdMeasSeq 
      BackColor       =   &H00E0FFE0&
      Caption         =   "Measure Sequence"
      Height          =   600
      Left            =   6900
      Style           =   1  'Graphical
      TabIndex        =   56
      ToolTipText     =   "Proper sequence: Measure zeros then measure live then zill DC and AC"
      Top             =   100
      Width           =   1000
   End
   Begin VB.TextBox txtCmd 
      Alignment       =   2  'Center
      BackColor       =   &H00FFFFFF&
      Height          =   300
      Left            =   6000
      TabIndex        =   55
      TabStop         =   0   'False
      Text            =   "Last command sent"
      ToolTipText     =   "Last commandsent"
      Top             =   2900
      Width           =   2000
   End
   Begin VB.Frame Frame7 
      Caption         =   "Phase"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   700
      Left            =   1300
      TabIndex        =   53
      Top             =   600
      Width           =   1000
      Begin VB.TextBox txtPhase 
         Alignment       =   2  'Center
         BackColor       =   &H00FFFFFF&
         Height          =   300
         Left            =   100
         MaxLength       =   4
         TabIndex        =   54
         TabStop         =   0   'False
         Text            =   "0"
         ToolTipText     =   "Phase angle to measure at, 0-359"
         Top             =   300
         Width           =   600
      End
   End
   Begin VB.CommandButton cmdMeasure 
      Caption         =   "Measure"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   400
      Left            =   1300
      Style           =   1  'Graphical
      TabIndex        =   52
      ToolTipText     =   "Sample everything at the set phase angle"
      Top             =   100
      Width           =   1000
   End
   Begin VB.CommandButton cmdSettings 
      Caption         =   "Settings"
      Height          =   300
      Left            =   100
      Style           =   1  'Graphical
      TabIndex        =   51
      ToolTipText     =   "Read back all the settings, and saturation flags"
      Top             =   2900
      Width           =   800
   End
   Begin VB.TextBox txtSettings 
      Alignment       =   2  'Center
      BackColor       =   &H00FFFFFF&
      Height          =   300
      Left            =   900
      TabIndex        =   50
      TabStop         =   0   'False
      Text            =   "Current settings unknown"
      ToolTipText     =   "Current settings: Q=Avg, G=Vgain, C=Igain, A=Vlevel, Flags:DCV, ACV, DCI, ACI (low, high)"
      Top             =   2900
      Width           =   4500
   End
   Begin VB.CheckBox chkReconnect 
      BackColor       =   &H00C0FFFF&
      Caption         =   "Always this unit"
      Height          =   225
      Left            =   4400
      TabIndex        =   49
      ToolTipText     =   "Always connect to the unit with this name"
      Top             =   2600
      Value           =   1  'Checked
      Width           =   1400
   End
   Begin VB.Frame framIP 
      Caption         =   "Unit Name and IP"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   725
      Left            =   1300
      TabIndex        =   47
      Top             =   2100
      Width           =   3000
      Begin VB.ListBox lstUnits 
         BackColor       =   &H00D0D0FF&
         Height          =   450
         ItemData        =   "formMain.frx":324A
         Left            =   100
         List            =   "formMain.frx":324C
         TabIndex        =   48
         ToolTipText     =   "Names of available units"
         Top             =   200
         Width           =   2800
      End
   End
   Begin VB.CommandButton cmdAutoClear 
      BackColor       =   &H00E0FFE0&
      Caption         =   "Clear"
      Height          =   300
      Left            =   9300
      Style           =   1  'Graphical
      TabIndex        =   46
      ToolTipText     =   "Clear the scan window"
      Top             =   2600
      Width           =   600
   End
   Begin VB.TextBox txtData 
      Height          =   3600
      Left            =   100
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   45
      Top             =   3300
      Width           =   9800
   End
   Begin VB.Timer tmrAuto 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   9400
      Top             =   1470
   End
   Begin VB.Frame Frame9 
      BackColor       =   &H00E0FFE0&
      Caption         =   "Scan Automation"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2550
      Left            =   8000
      TabIndex        =   32
      Top             =   100
      Width           =   1900
      Begin VB.CommandButton cmdAutoStop 
         BackColor       =   &H00E0FFE0&
         Caption         =   "Stop"
         Height          =   300
         Left            =   800
         Style           =   1  'Graphical
         TabIndex        =   43
         Top             =   1750
         Width           =   600
      End
      Begin VB.TextBox txtDcvDwell 
         Alignment       =   2  'Center
         BackColor       =   &H00E0FFE0&
         Height          =   300
         Left            =   100
         MaxLength       =   4
         TabIndex        =   38
         TabStop         =   0   'False
         Text            =   "100"
         ToolTipText     =   "Time in mS between DC voltage steps (1 to 1000)"
         Top             =   1400
         Width           =   750
      End
      Begin VB.TextBox txtDcvStep 
         Alignment       =   2  'Center
         BackColor       =   &H00E0FFE0&
         Height          =   300
         Left            =   100
         MaxLength       =   6
         TabIndex        =   37
         TabStop         =   0   'False
         Text            =   "0.1"
         ToolTipText     =   "Normalized DC voltage step (0.001 to 0.5)"
         Top             =   1100
         Width           =   750
      End
      Begin VB.TextBox txtDcvEnd 
         Alignment       =   2  'Center
         BackColor       =   &H00E0FFE0&
         Height          =   300
         Left            =   100
         MaxLength       =   6
         TabIndex        =   36
         TabStop         =   0   'False
         Text            =   "1"
         ToolTipText     =   "Normalized ending DC voltage (1.000)"
         Top             =   700
         Width           =   750
      End
      Begin VB.TextBox txtDcvStart 
         Alignment       =   2  'Center
         BackColor       =   &H00E0FFE0&
         Height          =   300
         Left            =   100
         MaxLength       =   6
         TabIndex        =   35
         TabStop         =   0   'False
         Text            =   "0"
         ToolTipText     =   "Normalized starting DC voltage (1.000)"
         Top             =   300
         Width           =   750
      End
      Begin VB.TextBox txtDcvUnderTest 
         Alignment       =   2  'Center
         BackColor       =   &H00E0FFE0&
         Height          =   300
         Left            =   100
         Locked          =   -1  'True
         TabIndex        =   34
         TabStop         =   0   'False
         Text            =   "---"
         ToolTipText     =   "Current DC voltage under test"
         Top             =   2150
         Width           =   750
      End
      Begin VB.CommandButton cmdAutoStart 
         BackColor       =   &H00E0FFE0&
         Caption         =   "Start"
         Height          =   300
         Left            =   100
         Style           =   1  'Graphical
         TabIndex        =   33
         Top             =   1750
         Width           =   600
      End
      Begin VB.Label Label15 
         AutoSize        =   -1  'True
         BackColor       =   &H00E0FFE0&
         Caption         =   "Currently"
         Height          =   195
         Left            =   855
         TabIndex        =   44
         Top             =   2145
         Width           =   615
      End
      Begin VB.Label Label14 
         AutoSize        =   -1  'True
         BackColor       =   &H00E0FFE0&
         Caption         =   "Dwell"
         Height          =   195
         Left            =   855
         TabIndex        =   42
         Top             =   1395
         Width           =   390
      End
      Begin VB.Label Label13 
         AutoSize        =   -1  'True
         BackColor       =   &H00E0FFE0&
         Caption         =   "DC-V Step"
         Height          =   195
         Left            =   855
         TabIndex        =   41
         Top             =   1095
         Width           =   750
      End
      Begin VB.Label Label12 
         AutoSize        =   -1  'True
         BackColor       =   &H00E0FFE0&
         Caption         =   "DC-V End"
         Height          =   195
         Left            =   855
         TabIndex        =   40
         Top             =   705
         Width           =   705
      End
      Begin VB.Label Label11 
         AutoSize        =   -1  'True
         BackColor       =   &H00E0FFE0&
         Caption         =   "DC-V Start"
         Height          =   195
         Left            =   855
         TabIndex        =   39
         Top             =   300
         Width           =   750
      End
   End
   Begin VB.Frame Frame8 
      Caption         =   "AC-I Gain"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1500
      Left            =   3600
      TabIndex        =   26
      Top             =   100
      Width           =   1100
      Begin VB.CheckBox chkAcIGain3 
         Caption         =   "X3"
         Height          =   200
         Left            =   100
         TabIndex        =   31
         Top             =   1200
         Width           =   600
      End
      Begin VB.OptionButton optAcIGain 
         Caption         =   "1"
         Height          =   200
         Index           =   0
         Left            =   100
         TabIndex        =   30
         ToolTipText     =   "AC current measurement gain = 1 (or 3)"
         Top             =   300
         Value           =   -1  'True
         Width           =   750
      End
      Begin VB.OptionButton optAcIGain 
         Caption         =   "10"
         Height          =   200
         Index           =   1
         Left            =   100
         TabIndex        =   29
         ToolTipText     =   "AC current measurement gain = 10 (or 30)"
         Top             =   500
         Width           =   750
      End
      Begin VB.OptionButton optAcIGain 
         Caption         =   "100"
         Height          =   200
         Index           =   2
         Left            =   100
         TabIndex        =   28
         ToolTipText     =   "AC current measurement gain = 100 (or 300)"
         Top             =   700
         Width           =   750
      End
      Begin VB.OptionButton optAcIGain 
         Caption         =   "1,000"
         Enabled         =   0   'False
         Height          =   200
         Index           =   3
         Left            =   100
         TabIndex        =   27
         ToolTipText     =   "AC current measurement gain = 1,000 (or 3,000)"
         Top             =   900
         Width           =   750
      End
   End
   Begin VB.Frame Frame6 
      Caption         =   "AC-V Gain"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1500
      Left            =   2400
      TabIndex        =   12
      Top             =   100
      Width           =   1100
      Begin VB.OptionButton optAcVGain 
         Caption         =   "1,000"
         Enabled         =   0   'False
         Height          =   200
         Index           =   3
         Left            =   100
         TabIndex        =   17
         ToolTipText     =   "AC voltage measurement gain = 1,000 (or 3,000)"
         Top             =   900
         Width           =   750
      End
      Begin VB.OptionButton optAcVGain 
         Caption         =   "100"
         Height          =   200
         Index           =   2
         Left            =   100
         TabIndex        =   16
         ToolTipText     =   "AC voltage measurement gain = 100 (or 300)"
         Top             =   700
         Width           =   750
      End
      Begin VB.OptionButton optAcVGain 
         Caption         =   "10"
         Height          =   200
         Index           =   1
         Left            =   100
         TabIndex        =   15
         ToolTipText     =   "AC voltage measurement gain = 10 (or 30)"
         Top             =   500
         Width           =   750
      End
      Begin VB.OptionButton optAcVGain 
         Caption         =   "1"
         Height          =   200
         Index           =   0
         Left            =   100
         TabIndex        =   14
         ToolTipText     =   "AC voltage measurement gain = 1 (or 3)"
         Top             =   300
         Value           =   -1  'True
         Width           =   750
      End
      Begin VB.CheckBox chkAcVGain3 
         Caption         =   "X3"
         Height          =   200
         Left            =   100
         TabIndex        =   13
         Top             =   1200
         Width           =   600
      End
   End
   Begin VB.Frame Frame5 
      Caption         =   "ADCs"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1800
      Left            =   4800
      TabIndex        =   9
      Top             =   100
      Width           =   1400
      Begin VB.TextBox txtIac 
         Alignment       =   2  'Center
         BackColor       =   &H00FFFFFF&
         Height          =   300
         Left            =   100
         Locked          =   -1  'True
         TabIndex        =   20
         TabStop         =   0   'False
         Text            =   "???"
         ToolTipText     =   "Measured AC current, raw ADC, 0 to 65,535"
         Top             =   1400
         Width           =   750
      End
      Begin VB.TextBox txtVac 
         Alignment       =   2  'Center
         BackColor       =   &H00FFFFFF&
         Height          =   300
         Left            =   100
         Locked          =   -1  'True
         TabIndex        =   19
         TabStop         =   0   'False
         Text            =   "???"
         ToolTipText     =   "Measured AC voltage, raw ADC, 0 to 65,535"
         Top             =   700
         Width           =   750
      End
      Begin VB.TextBox txtIdc 
         Alignment       =   2  'Center
         BackColor       =   &H00FFFFFF&
         Height          =   300
         Left            =   100
         Locked          =   -1  'True
         TabIndex        =   18
         TabStop         =   0   'False
         Text            =   "???"
         ToolTipText     =   "Measured DC current, raw ADC, 0 to 65,535"
         Top             =   1100
         Width           =   750
      End
      Begin VB.TextBox txtVdc 
         Alignment       =   2  'Center
         BackColor       =   &H00FFFFFF&
         Height          =   300
         Left            =   100
         Locked          =   -1  'True
         TabIndex        =   10
         TabStop         =   0   'False
         Text            =   "???"
         ToolTipText     =   "Measured DC voltage, raw ADC, 0 to 65,535"
         Top             =   300
         Width           =   750
      End
      Begin VB.Label Label6 
         AutoSize        =   -1  'True
         Caption         =   "AC-I"
         Height          =   195
         Left            =   855
         TabIndex        =   23
         Top             =   1395
         Width           =   300
      End
      Begin VB.Label Label5 
         AutoSize        =   -1  'True
         Caption         =   "DC-I"
         Height          =   195
         Left            =   855
         TabIndex        =   22
         Top             =   1095
         Width           =   315
      End
      Begin VB.Label Label4 
         AutoSize        =   -1  'True
         Caption         =   "AC-V"
         Height          =   195
         Left            =   855
         TabIndex        =   21
         Top             =   705
         Width           =   360
      End
      Begin VB.Label Label3 
         AutoSize        =   -1  'True
         Caption         =   "DC-V"
         Height          =   195
         Left            =   855
         TabIndex        =   11
         Top             =   300
         Width           =   375
      End
   End
   Begin VB.Frame Frame4 
      Caption         =   "Average"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   700
      Left            =   1300
      TabIndex        =   8
      Top             =   1350
      Width           =   1000
      Begin VB.TextBox txtAvg 
         Alignment       =   2  'Center
         BackColor       =   &H00FFFFFF&
         Height          =   300
         Left            =   100
         MaxLength       =   4
         TabIndex        =   25
         TabStop         =   0   'False
         Text            =   "100"
         ToolTipText     =   "Samples in averaging, 1 to 9999"
         Top             =   300
         Width           =   600
      End
   End
   Begin VB.Frame Frame3 
      Caption         =   "AC Drive"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   700
      Left            =   100
      TabIndex        =   6
      Top             =   1650
      Width           =   1100
      Begin VB.TextBox txtPotA 
         Alignment       =   2  'Center
         BackColor       =   &H00FFFFFF&
         Height          =   300
         Left            =   300
         MaxLength       =   3
         TabIndex        =   7
         TabStop         =   0   'False
         Text            =   "0"
         ToolTipText     =   "AC signal level, 0-255, unitless"
         Top             =   300
         Width           =   500
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "DC-V"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   700
      Left            =   100
      TabIndex        =   4
      Top             =   100
      Width           =   1100
      Begin VB.TextBox txtDCV 
         Alignment       =   2  'Center
         BackColor       =   &H00FFFFFF&
         Height          =   300
         Left            =   100
         MaxLength       =   6
         TabIndex        =   5
         TabStop         =   0   'False
         Text            =   "+0.000"
         ToolTipText     =   "Normalized DC voltage, 1.000"
         Top             =   300
         Width           =   750
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Frequency"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   750
      Left            =   100
      TabIndex        =   2
      Top             =   900
      Width           =   1100
      Begin VB.TextBox txtFreq 
         Alignment       =   2  'Center
         BackColor       =   &H00FFFFFF&
         Height          =   300
         Left            =   100
         MaxLength       =   4
         TabIndex        =   3
         TabStop         =   0   'False
         Text            =   "1000"
         ToolTipText     =   "Frequency in Hz, 25-1000Hz"
         Top             =   300
         Width           =   750
      End
   End
   Begin VB.Timer tmrHB 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   3255
      Top             =   1575
   End
   Begin MSWinsockLib.Winsock Enet 
      Left            =   2835
      Top             =   1575
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
      Protocol        =   1
   End
   Begin VB.Label lblHostVer 
      Appearance      =   0  'Flat
      AutoSize        =   -1  'True
      BackColor       =   &H00C0FFFF&
      Caption         =   "Host:"
      ForeColor       =   &H80000008&
      Height          =   195
      Left            =   4700
      TabIndex        =   24
      ToolTipText     =   "Unit's firmware version"
      Top             =   2150
      Width           =   375
   End
   Begin VB.Label lblUnitName 
      Appearance      =   0  'Flat
      AutoSize        =   -1  'True
      BackColor       =   &H00C0FFFF&
      Caption         =   "Unit name: ?"
      ForeColor       =   &H80000008&
      Height          =   195
      Left            =   4700
      TabIndex        =   1
      ToolTipText     =   "Unit's name"
      Top             =   2350
      Width           =   900
   End
   Begin VB.Label lblVerRabbit 
      Appearance      =   0  'Flat
      AutoSize        =   -1  'True
      BackColor       =   &H00C0FFFF&
      Caption         =   "Firmware: ?"
      ForeColor       =   &H80000008&
      Height          =   195
      Left            =   4700
      TabIndex        =   0
      ToolTipText     =   "Unit's firmware version"
      Top             =   1950
      Width           =   810
   End
End
Attribute VB_Name = "formMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
DefVar A-Z

Const PORT = 37829                                                               'always this port.
Const KeyScope = KEY_LOCAL_MACHINE                   'select KEY_CURRENT_USER or KEY_LOCAL_MACHINE.
Const KeyPath = "SOFTWARE\SD\DiffCon"    'path: HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\SD\DiffCon.
Const LOSS_OF_UNIT_TIMEOUT = 2.5                    'time for loss of heartbeat until acknowledged.
Const MIN_FREQ = 25                                                         'minimum frequency, Hz.
Const MAX_FREQ = 1000                                                       'maximum frequency, Hz.
    
Const DARK_RED = &H4040FF
Const LIGHT_RED = &H7070FF
Const PINK = &HD0D0FF
Const LIGHT_BLUE = &HFFFFE0
Const WHITE = &H80000005
Const LIGHT_GREEN = &HC0FFC0

Dim LastHbIn, AutoDCV As Single, AutoState As Integer, AvgCount As Integer, UnitName As String
Dim MeasSeqState, MeasSeqTime
Dim StartWidth, StartHeight

Private Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" (ByVal lpszSoundName As String, ByVal uFlags As Long) As Long

Private Function Send2Unit(Cmd As String)

   If lstUnits.BackColor = WHITE Then
      Enet.SendData Cmd
      txtCmd = Cmd
   End If

End Function

Private Function SendAllSettings()
   Dim CurSec

   txtDCV_Change                                                                'update DC voltage.
   CurSec = Timer: While CurSec + 0.25 > Timer: Wend
   txtFreq_Change                                                         'update set AC frequency.
   CurSec = Timer: While CurSec + 0.25 > Timer: Wend      'pause 250mS for commands to take effect.
   txtPotA_Change                                                        'update both pot settings.
   CurSec = Timer: While CurSec + 0.25 > Timer: Wend
   txtPhase_Change                                                             'update phase angle.
   CurSec = Timer: While CurSec + 0.25 > Timer: Wend
   txtAvg_Change                                                           'update averaging count.
   CurSec = Timer: While CurSec + 0.25 > Timer: Wend
   chkAcVGain3_Click                                        'update AC-V measurement gain settings.
   CurSec = Timer: While CurSec + 0.25 > Timer: Wend
   chkAcIGain3_Click                                                       'update AC current gain.
   CurSec = Timer: While CurSec + 0.25 > Timer: Wend

End Function


Private Sub chkAcIGain3_Click()

   Dim Ptr

   KeySave KeyScope, KeyPath, "AC Current Gain X3", chkAcIGain3                           'save it.
   
   If lstUnits.BackColor = WHITE Then
      For Ptr = 0 To 3                                              'which decade gain is selected?
         If optAcIGain(Ptr) Then
            If chkAcIGain3.Value = 0 Then                                   'Find X3 gain and send.
               Send2Unit "C1" + Trim(Str(Ptr))
               optAcIGain(0).Caption = "1"
               optAcIGain(1).Caption = "10"
               optAcIGain(2).Caption = "100"
               optAcIGain(3).Caption = "1,000"
            Else
               Send2Unit "C3" + Trim(Str(Ptr))
               optAcIGain(0).Caption = "3"
               optAcIGain(1).Caption = "30"
               optAcIGain(2).Caption = "300"
               optAcIGain(3).Caption = "3,000"
            End If
         End If
      Next
   End If
   
End Sub

Private Sub chkAcVGain3_Click()

   Dim Ptr

   KeySave KeyScope, KeyPath, "AC Voltage Gain X3", chkAcVGain3                           'save it.
   
   If lstUnits.BackColor = WHITE Then
      For Ptr = 0 To 3                                              'which decade gain is selected?
         If optAcVGain(Ptr) Then
            If chkAcVGain3.Value = 0 Then                                   'Find X3 gain and send.
               Send2Unit "G1" + Trim(Str(Ptr))
               optAcVGain(0).Caption = "1"
               optAcVGain(1).Caption = "10"
               optAcVGain(2).Caption = "100"
               optAcVGain(3).Caption = "1,000"
            Else
               Send2Unit "G3" + Trim(Str(Ptr))
               optAcVGain(0).Caption = "3"
               optAcVGain(1).Caption = "30"
               optAcVGain(2).Caption = "300"
               optAcVGain(3).Caption = "3,000"
            End If
         End If
      Next
   End If
   
End Sub

Private Sub chkReconnect_Click()

   KeySave KeyScope, KeyPath, "Always this unit", chkReconnect

End Sub

Private Sub cmdAutoClear_Click()

   txtData = ""

End Sub

Private Sub cmdAutoStart_Click()

   If lstUnits.BackColor = LIGHT_RED _
     Or txtDcvStart.BackColor = LIGHT_RED _
     Or txtDcvEnd.BackColor = LIGHT_RED _
     Or txtDcvStep.BackColor = LIGHT_RED _
     Or txtDcvDwell.BackColor = LIGHT_RED _
     Or Val(txtDcvStep) = 0 Then Exit Sub                            'ALL PARAMETERS WITHIN LIMITS?
   
   If Val(txtDcvStart) < Val(txtDcvEnd) And Val(txtDcvStep) < 0 Then Exit Sub    'SCAN TOWARDS END?
   If Val(txtDcvStart) > Val(txtDcvEnd) And Val(txtDcvStep) > 0 Then Exit Sub
   
   tmrAuto.Interval = Val(txtDcvDwell)                                            'GOOD FOR LAUNCH.
   AutoState = 1                                             'this is the flag to say in auto mode.
   AutoDCV = Val(txtDcvStart)                                                    'starting voltage.
   tmrAuto.Enabled = True

End Sub

Private Sub cmdAutoStop_Click()

   tmrAuto.Enabled = False
   AutoState = 0                                   'this is the flag to say no longer in auto mode.
   txtDcvUnderTest = "---"

End Sub


Private Sub cmdMeasSeq_Click()  'Real measureing sequence: measure zeros with no DC or AC, _
                                 set DC and AC and measure live, then display differences.

   Dim Dwell As Integer
   Static CurSec, MeasVdc0, MeasIdc0, MeasVac0, MeasIac0
   
   Dwell = txtDwellSeq
   If Dwell < 10 Then Dwell = 10
   If Dwell > 5000 Then Dwell = 5000
   
   If MeasSeqState = 0 Then                                                'SETUP TO MEASURE ZEROS.
      Send2Unit "D+0.000"                                                          'Kill DC And AC.
      Send2Unit "A000"
      CurSec = Timer:  While CurSec + (Dwell / 1000) > Timer: Wend    'pause for DC to take effect.
      txtIac = "???"                                                                   'set marker.
      Send2Unit "M"                                                 'send command to measure zeros.
      MeasSeqState = 1                                'next state is to read the zero measurements.
      MeasSeqTime = 0                                                       'reset timeout counter.
      tmrMeasSeq.Enabled = True                                             'now poll for the data.
      MousePointer = vbHourglass
   End If
      
   If MeasSeqState = 2 Then                                                            'SAVE ZEROS.
      MeasVdc0 = txtVdc                                                                     'zeros.
      MeasIdc0 = txtIdc
      MeasVac0 = txtVac
      MeasIac0 = txtIac
      
      txtDCV_Change                                                    'SETUP TO MEASURE LIVE DATA.
      txtPotA_Change                                                   'restore DC and AC settings.
      CurSec = Timer:  While CurSec + (Dwell / 1000) > Timer: Wend    'pause for DC to take effect.
      txtIac = "???"                                                                   'set marker.
      Send2Unit "M"                                                 'send command to measure zeros.
      MeasSeqTime = 0                                                       'reset timeout counter.
      tmrMeasSeq.Enabled = True                                             'now poll for the data.
   End If
   
   If MeasSeqState = 3 Then                                      'HAVE LIVE DATA, CALCULATE VALUES.
      txtVdc = txtVdc - MeasVdc0
      txtIdc = txtIdc - MeasIdc0
      txtVac = txtVac - MeasVac0
      txtIac = txtIac - MeasIac0
      Send2Unit "D+0.000"                                                          'kill DC And AC.
      Send2Unit "A000"
      Send2Unit "S"                                                          'request all settings.
      MeasSeqState = 0
      MousePointer = vbNormal
   End If
   
End Sub

Private Sub cmdMeasure_Click()

   Send2Unit "M"
   Send2Unit "S"                                                             'request all settings.

End Sub

Private Sub cmdSettings_Click()

   Send2Unit "S"                                                             'REQUEST ALL SETTINGS.

End Sub

Private Sub Enet_DataArrival(ByVal bytesTotal As Long)             'Note that tmrAuto_Timer() and _
                                       Enet_DataArrival() ping pong back and forth as data arrives.
   Dim Incoming As String, Tmp As Single, Txt As String, Ptr

   On Local Error Resume Next                       'cause sometimes the ethernet might lose bytes?
   LastHbIn = Timer
   Enet.GetData Incoming

   If Enet.RemoteHost <> "" And lstUnits.BackColor <> WHITE Then             'JUST MADE CONNECTION.
      lstUnits.BackColor = WHITE                                                        'connected.
      SendAllSettings
      cmdSettings_Click                                                    'read back all settings.
      On Local Error Resume Next
      sndPlaySound App.Path + "\ConnectedNow.wav", 1
   End If
                                           'NB: Type identifier for Diff Conn is "D", the second byte.
   If Left(Incoming, 2) = "ID" Then                             'INCOMING IP ADDRESS AND UNIT NAME.
      Txt = Mid(Incoming, 3, 20) + "   (" + Right(Incoming, 15)
      For Ptr = 0 To lstUnits.ListCount - 1
         If Txt = lstUnits.List(Ptr) Then Exit For                        'already know about unit.
      Next
      If Ptr = 0 Or Ptr < lstUnits.ListCount Then                                        'New Unit.
         lstUnits.AddItem Mid(Incoming, 3, 20) + "   " + Mid(Incoming, 22, 15)
         If Mid(Incoming, 3, 20) = UnitName Then _
            Enet.RemoteHost = Trim(Mid(Incoming, 22, 15))             'is the last unit so connect.
      End If
   End If
   
   If Left(Incoming, 1) = "S" Then                                                   'ALL SETTINGS.
      If Len(Incoming) = 48 Then                                          'should be 48 chars long.
         txtSettings = Incoming
         txtData = Incoming + vbCrLf + txtData                                     'show with data.
         If Mid(Incoming, 40, 2) = "00" Then txtVdc.BackColor = WHITE Else txtVdc.BackColor = LIGHT_RED
         If Mid(Incoming, 42, 2) = "00" Then txtVac.BackColor = WHITE Else txtVac.BackColor = LIGHT_RED
         If Mid(Incoming, 44, 2) = "00" Then txtIdc.BackColor = WHITE Else txtIdc.BackColor = LIGHT_RED
         If Mid(Incoming, 46, 2) = "00" Then txtIac.BackColor = WHITE Else txtIac.BackColor = LIGHT_RED
      Else
         txtSettings = "???"
      End If
   End If
   
   
   If Left(Incoming, 1) = "V" Then                                'RABBIT AND FPGA VERSION STRINGS.
      Incoming = Right(Incoming, Len(Incoming) - 1) + Space(20)             'remove the "V" header.
      lblVerRabbit = "Firmware: " + Left(Incoming, InStr(Incoming, Chr(10)) - 1)   'Rabbit version.
      Incoming = Right(Incoming, Len(Incoming) - InStr(Incoming, Chr(10)))
      lblUnitName = Trim(Incoming)                                            'extract unit's name.
      Incoming = ""
   End If
   
   
   If Left(Incoming, 1) = "D" Then                                               'DATA, ADC VALUES.
      If Len(Incoming) = 21 Then
         txtVdc = Trim(Mid(Incoming, 2, 5))                                                  'DC-V.
         txtVac = Trim(Mid(Incoming, 7, 5))                                                  'AC-V.
         txtIdc = Trim(Mid(Incoming, 12, 5))                                                 'DC-I.
         txtIac = Trim(Mid(Incoming, 17, 5))                                                 'AC-I.
         txtData = Mid(Incoming, 2, 5) + "  " _
                 + Mid(Incoming, 7, 5) + "  " _
                 + Mid(Incoming, 12, 5) + "  " _
                 + Mid(Incoming, 17, 5) + vbCrLf + txtData
         
         If AutoState > 0 Then                                             'AUTOMATION MEASUREMENT.
            AutoState = 1
            tmrAuto.Enabled = True
         End If
      
      Else
         txtVdc = "???"
         txtVac = "???"
         txtIdc = "???"
         txtIac = "???"
      End If
   End If
   
   On Local Error GoTo 0

End Sub

Private Sub Form_Load()

  Dim GoodKey, Txt As String, Ch As Integer                    'Goodkey reduces key reading errors.
  Dim KeyAcV As String, KeyAcI As String, KeyAcV3 As String, KeyAcI3 As String
   
   If App.PrevInstance Then                                           'Only a GUI instance running.
      MsgBox "Already a GUI running!", vbOK, "Pulsar"
      End
   End If
   lblHostVer = "Host: " + RevisionLabel
   
   On Local Error Resume Next
   Open App.Path + "\ConnectedNow.wav" For Random As #1    'create empty sound files if none exist.
   Open App.Path + "\ConnectionLost.wav" For Random As #2
   Close
   StartWidth = Width
   StartHeight = Height
   MeasSeqState = 0                                   'state machine for proper measuring sequence.
   
   Enet.RemotePort = PORT                                                    'SETUP LOCAL UDP PORT.
   Enet.LocalPort = PORT
   Enet.Bind
   
   GoodKey = KeyGet(KeyScope, KeyPath, "Always this unit", Txt)       'Always connect to this unit.
   If GoodKey And Txt = 0 Then chkReconnect = 0
   
   GoodKey = KeyGet(KeyScope, KeyPath, "Last unit name", Txt)              'Reconnect to last unit.
   If GoodKey And Len(Txt) = 20 And chkReconnect Then UnitName = Txt
  
   GoodKey = KeyGet(KeyScope, KeyPath, "Left", Txt)                                          'Left.
   If GoodKey Then Left = Val(Txt)
  
   GoodKey = KeyGet(KeyScope, KeyPath, "Top", Txt)                                            'Top.
   If GoodKey Then Top = Val(Txt)
   
   GoodKey = KeyGet(KeyScope, KeyPath, "Frequency", Txt)                                'Frequency.
   If GoodKey Then txtFreq = Val(Txt)
   txtFreq_Change
   
   GoodKey = KeyGet(KeyScope, KeyPath, "Phase", Txt)                                        'Phase.
   If GoodKey Then txtPhase = Val(Txt)
   
   GoodKey = KeyGet(KeyScope, KeyPath, "Sequence Dwell Time", Txt)            'Sequence Dwell Time.
   If GoodKey Then txtDwellSeq = Val(Txt)
   
   
   GoodKey = KeyGet(KeyScope, KeyPath, "AC Voltage Gain Decade", KeyAcV)         'AC-V Gain Decade.
   GoodKey = KeyGet(KeyScope, KeyPath, "AC Current Gain Decade", KeyAcI)         'AC-I Gain Decade.
   GoodKey = KeyGet(KeyScope, KeyPath, "AC Voltage Gain X3", KeyAcV3)                'AC-V Gain X3.
   GoodKey = KeyGet(KeyScope, KeyPath, "AC Current Gain X3", KeyAcI3)                'AC-I Gain X3.
   If GoodKey And Val(KeyAcV3) = 1 Then chkAcVGain3.Value = 1
   If GoodKey And Val(KeyAcI3) = 1 Then chkAcIGain3.Value = 1
   If GoodKey And Val(KeyAcV) >= 0 And Val(KeyAcV) < 4 Then optAcVGain(Int(Val(KeyAcV))).Value = 1
   If GoodKey And Val(KeyAcI) >= 0 And Val(KeyAcI) < 4 Then optAcIGain(Int(Val(KeyAcI))).Value = 1
   
   GoodKey = KeyGet(KeyScope, KeyPath, "Averaging", Txt)                                'Averaging.
   If GoodKey Then txtAvg = Int(Val(Txt))
   txtAvg_Change
   
   GoodKey = KeyGet(KeyScope, KeyPath, "Pot A", Txt)                                         'Pots.
   If GoodKey Then txtPotA = Val(Txt)
   txtPotA_Change
   
   GoodKey = KeyGet(KeyScope, KeyPath, "Auto DC Voltage Start", Txt)              'Auto DC-V Start.
   If GoodKey Then txtDcvStart = Txt
   txtDcvStart_Change
   
   GoodKey = KeyGet(KeyScope, KeyPath, "Auto DC Voltage End", Txt)                  'Auto DC-V End.
   If GoodKey Then txtDcvEnd = Txt
   txtDcvEnd_Change
   
   GoodKey = KeyGet(KeyScope, KeyPath, "Auto DC Voltage Step", Txt)                'Auto DC-V Step.
   If GoodKey Then txtDcvStep = Txt
   txtDcvStep_Change
   
   GoodKey = KeyGet(KeyScope, KeyPath, "Auto DC Voltage Dwell", Txt)              'Auto DC-V Dwell.
   If GoodKey Then txtDcvDwell = Txt
   txtDcvDwell_Change
   
   cmdAutoClear_Click
   tmrHB.Enabled = True

End Sub

Private Sub Form_Resize()

   If WindowState = vbMinimized Then Exit Sub                               'ignore, now minimized.

   Width = StartWidth                                                                 'fixed width.
   
   If Height < StartHeight Then Height = StartHeight                               'minumum height.

   txtData.Height = Height - 3930

End Sub


Private Sub Form_Terminate()

  Form_Unload (0)

End Sub

Private Sub Form_Unload(Cancel As Integer)

   Enet.Close
   
   MousePointer = vbHourglass
   Refresh
   Close
   If lstUnits.BackColor = WHITE Then Send2Unit "S"      'clear saturation flags, for reconnection.
   
   KeySave KeyScope, KeyPath, "Left", Left
   KeySave KeyScope, KeyPath, "Top", Top
   KeySave KeyScope, KeyPath, "Window state", WindowState
   End

End Sub


Private Sub lstUnits_DblClick()

   On Local Error GoTo BadID

   UnitName = Left(lstUnits.List(lstUnits.ListIndex), 20)
   KeySave KeyScope, KeyPath, "Last Unit Name", UnitName               'save unit name in registry.
   Enet.RemoteHost = Trim(Right(lstUnits.List(lstUnits.ListIndex), 15))           'connect to unit.

BadID:
End Sub


Private Sub optAcIGain_Click(Index As Integer)

   KeySave KeyScope, KeyPath, "AC Current Gain Decade", Trim(Str(Index))                  'save it.
   
   chkAcIGain3_Click                                                                 'send to unit.

End Sub

Private Sub optAcVgain_Click(Index As Integer)

   KeySave KeyScope, KeyPath, "AC Voltage Gain Decade", Trim(Str(Index))                  'save it.
   
   chkAcVGain3_Click                                                                 'send to unit.

End Sub



Private Sub tmrAuto_Timer()  'In Scan Automation mode, time for next measurement or setting. _
         Note that tmrAuto_Timer() and Enet_DataArrival() ping pong back and forth as data arrives.
   
   Select Case AutoState
      Case 1:                                                                         'SET DC ZERO.
         AutoState = 2
         Enet.SendData "D+0.000"                                                  'set to zero DCV.
         Enet.SendData "A00"                                                      'reset both pots.
         Exit Sub
      
      Case 2:                                                       'MEASURE ALL ADCS AT SET PHASE.
         tmrAuto.Interval = Val(txtDcvDwell)               'just in case it was changed on the fly.
         tmrAuto.Enabled = False                       'when data arrives, timer will be restarted.
         AutoDCV = AutoDCV + txtDcvStep                                   'step to next DC voltage.
         txtDcvUnderTest = AutoDCV                                                 '...and show it.
         If AutoDCV = 1 Then
            Enet.SendData "D+1.000"                                                'request +1.000.
         ElseIf AutoDCV = -1 Then
            Enet.SendData "D-1.000"                                                'request -1.000.
         Else
            Enet.SendData "D" + Left(Trim(Str(Val(AutoDCV))) + "00000", 6)      'send next voltage.
         End If
         
         Enet.SendData "M"                                             'measure at set phase angle.
         
         If txtDcvStep > 0 And AutoDCV >= txtDcvEnd Then AutoState = 0                   'END SCAN.
         If txtDcvStep < 0 And AutoDCV <= txtDcvEnd Then AutoState = 0
   End Select
   
End Sub


Private Sub tmrHB_Timer()   'Always send a heartbeat.  If no heartbeat sent back for a few _
                             seconds then assume lost contact with ChromaMatic2.

   On Local Error Resume Next
   Enet.SendData "H"                                                             'send a heartbeat.

   If LastHbIn + LOSS_OF_UNIT_TIMEOUT < Timer Then                   'lost contact to ChromaMatic2.
      On Local Error Resume Next
      If lstUnits.BackColor <> PINK Then
         lstUnits.BackColor = PINK
         txtDCV = "+0.000"
         txtSettings = "Current settings unknown"
         sndPlaySound App.Path + "\ConnectionLost.wav", 1
      End If
   End If
   On Local Error GoTo 0
   
End Sub

Private Sub tmrMeasSeq_Timer()  'Part of proper measurement sequence, poll for data every 100mS.
   If MeasSeqState = 0 Then tmrMeasSeq.Enabled = False                              'invalid state.

   If txtIac <> "???" Then                                                       'DATA HAS ARRIVED.
      tmrMeasSeq.Enabled = False
      MeasSeqState = MeasSeqState + 1                                     'return and process data.
      cmdMeasSeq_Click
   Else
      MeasSeqTime = MeasSeqTime + 1                                               'still waiting...
      If MeasSeqTime = 20 Then                                               'timed out, 2 seconds.
         tmrMeasSeq.Enabled = False
         MeasSeqState = 0
         MousePointer = vbNormal
      End If
   End If

End Sub

Private Sub txtAvg_Change()

   txtAvg.BackColor = LIGHT_RED                                        'assume that setting is bad.
   
   txtAvg = Trim(txtAvg)
   
   If Trim(txtAvg) = "" Then Exit Sub                                                 'BAD SETTING?
   If txtAvg <> Int(txtAvg) Then Exit Sub
   If txtAvg < 1 Then Exit Sub
   If txtAvg > 9999 Then Exit Sub

   txtAvg.BackColor = WHITE                                                          'GOOD SETTING!
   KeySave KeyScope, KeyPath, "Averaging", txtAvg                                         'save it.
   If lstUnits.BackColor = WHITE Then
      Send2Unit "Q" + Right("000" + Trim(txtAvg), 4)                                      'send it.
   End If
   
End Sub


Private Sub txtDCV_Change()

   txtDCV.BackColor = LIGHT_RED                                        'assume that voltage is bad.
   txtDCV = Trim(txtDCV)
   
   If Val(txtDCV) < -1 Then Exit Sub                                                  'BAD VOLTAGE?
   If Val(txtDCV) > 1 Then Exit Sub

   txtDCV.BackColor = WHITE                                                          'GOOD VOLTAGE!
   If lstUnits.BackColor <> WHITE Then Exit Sub
   
   If Val(txtDCV) = 1 Then                                                                'Send It.
      Send2Unit "D+1.000"                                                          'request +1.000.
   ElseIf Val(txtDCV) = -1 Then
      Send2Unit "D-1.000"                                                          'request -1.000.
   Else
      Send2Unit "D" + Left(Trim(Str(Val(txtDCV))) + "00000", 6)            'send requested voltage.
   End If

End Sub


Private Sub txtDcvDwell_Change()

   txtDcvDwell.BackColor = LIGHT_RED                                      'assume that time is bad.
   txtDcvDwell = Trim(txtDcvDwell)
   
   If Val(txtDcvDwell) <= 0 Then Exit Sub                                                'BAD TIME?
   If Val(txtDcvDwell) > 1000 Then Exit Sub

   txtDcvDwell.BackColor = &HE0FFE0                                                     'GOOD TIME!
   KeySave KeyScope, KeyPath, "Auto DC Voltage Dwell", txtDcvDwell                                        'save it.

End Sub

Private Sub txtDcvEnd_Change()

   txtDcvEnd.BackColor = LIGHT_RED                                     'assume that voltage is bad.
   txtDcvEnd = Trim(txtDcvEnd)
   
   If Val(txtDcvEnd) < -1 Then Exit Sub                                               'BAD VOLTAGE?
   If Val(txtDcvEnd) > 1 Then Exit Sub

   txtDcvEnd.BackColor = &HE0FFE0                                                    'GOOD VOLTAGE!
   KeySave KeyScope, KeyPath, "Auto DC Voltage End", txtDcvEnd                                        'save it.

End Sub

Private Sub txtDcvStart_Change()

   txtDcvStart.BackColor = LIGHT_RED                                   'assume that voltage is bad.
   txtDcvStart = Trim(txtDcvStart)
   
   If Val(txtDcvStart) < -1 Then Exit Sub                                             'BAD VOLTAGE?
   If Val(txtDcvStart) > 1 Then Exit Sub

   txtDcvStart.BackColor = &HE0FFE0                                                  'GOOD VOLTAGE!
   KeySave KeyScope, KeyPath, "Auto DC Voltage Start", txtDcvStart                                        'save it.

End Sub

Private Sub txtDcvStep_Change()

   txtDcvStep.BackColor = LIGHT_RED                                    'assume that voltage is bad.
   txtDcvStep = Trim(txtDcvStep)
   
   If Val(txtDcvStep) < -0.5 Then Exit Sub                                            'BAD VOLTAGE?
   If Val(txtDcvStep) > 0.5 Then Exit Sub

   txtDcvStep.BackColor = &HE0FFE0                                                   'GOOD VOLTAGE!
   KeySave KeyScope, KeyPath, "Auto DC Voltage Step", txtDcvStep                                        'save it.

End Sub

Private Sub txtDwellSeq_Change()

   txtDwellSeq.BackColor = LIGHT_RED                                      'assume that time is bad.
   txtDwellSeq = Trim(txtDwellSeq)
   
   If Val(txtDwellSeq) <= 0 Then Exit Sub                                                'BAD TIME?
   If Val(txtDwellSeq) > 5000 Then Exit Sub

   txtDwellSeq.BackColor = &HE0FFE0                                                     'GOOD TIME!
   KeySave KeyScope, KeyPath, "Sequence Dwell Time", txtDwellSeq                                        'save it.

End Sub

Private Sub txtFreq_Change()

   txtFreq.BackColor = LIGHT_RED                                     'assume that frequency is bad.
   
   txtFreq = Trim(txtFreq)
   
   If txtFreq <> Int(txtFreq) Then Exit Sub                                         'BAD FREQUENCY?
   If txtFreq < MIN_FREQ Then Exit Sub
   If txtFreq > MAX_FREQ Then Exit Sub

   txtFreq.BackColor = WHITE                                                       'GOOD FREQUENCY!
   KeySave KeyScope, KeyPath, "Frequency", txtFreq                                        'save it.
   If lstUnits.BackColor = WHITE Then
      Send2Unit "F" + Right("000" + Trim(txtFreq), 4)                    'send requested frequency.
   End If

End Sub

Private Sub txtFreq_LostFocus()

   Dim GoodKey, Txt As String
   
   GoodKey = KeyGet(KeyScope, KeyPath, "Frequency", Txt)                  'GET LAST GOOD FREQUENCY.
   If GoodKey Then
      txtFreq = Val(Txt)
   Else
      txtFreq = MAX_FREQ
   End If

End Sub


Private Sub txtPhase_Change()

   txtPhase.BackColor = LIGHT_RED                                        'assume that phase is bad.
   
   txtPhase = Trim(txtPhase)
   
   If Len(Trim(txtPhase)) = 0 Then Exit Sub                                             'BAD PHASE?
   If txtPhase <> Int(txtPhase) Then Exit Sub
   If txtPhase < 0 Then Exit Sub
   If txtPhase > 359 Then Exit Sub

   txtPhase.BackColor = WHITE                                                          'GOOD PHASE!
   KeySave KeyScope, KeyPath, "Phase", txtPhase                                           'save it.
   If lstUnits.BackColor = WHITE Then
      Send2Unit "P" + Right("00" + Trim(txtPhase), 3)                        'send requested phase.
   End If

End Sub

Private Sub txtPotA_Change()

   txtPotA.BackColor = LIGHT_RED                                       'assume that setting is bad.
   
   txtPotA = Trim(txtPotA)
   
   If Trim(txtPotA) = "" Then Exit Sub                                                'BAD SETTING?
   If txtPotA <> Int(txtPotA) Then Exit Sub
   If txtPotA < 0 Then Exit Sub
   If txtPotA > 255 Then Exit Sub
   txtPotA.BackColor = WHITE
   If lstUnits.BackColor = LIGHT_RED Then Exit Sub

   KeySave KeyScope, KeyPath, "Pot A", txtPotA                                            'save it.
   If lstUnits.BackColor = WHITE Then
      Send2Unit "A" + Right("00" + Trim(txtPotA), 3)                   'send requested pot setting.
   End If

End Sub


